;City Storm
;by Shiru 10'2008 for ASCiI'08

; SjASMPlus

    device zxspectrum128

OP_INC_L    equ #2c
OP_DEC_L    equ #2d
OP_INC_H    equ #24
OP_DEC_H    equ #25

STACK_A     equ #2d28
FP_TO_A     equ #2dd5
STACK_BC    equ #2d2b
FP_TO_BC    equ #2da2

CLS         equ #0d6b
BORDER      equ #5c48
ATTR_P      equ #5c8d

    org #6200
 
begin

    di
    ld sp,#6200
 
;   

cls
    xor a
    out (#fe),a
    ld h,#5b
    dec hl
    ld (hl),a
    or (hl)
    jr z,$-3

;  r*r

gen_rr_table
    ld a,16
    out (#fd),a
    ld hl,rrTable
.loop0
    push hl
    ld b,0
    ld c,l
    push bc
    call STACK_BC
    pop bc
    call STACK_BC
    rst #28
    db #04 ;multiply
    db #38 ;end calc
    call FP_TO_BC
    pop hl
    ld (hl),c
    inc h
    ld (hl),b
    dec h
    inc l
    jr nz,.loop0

; 

sky_gen_noise

    ld h,#80
.loop0
    call rnd
    and 15
    cp 12
    jr c,.loop1
    add a,a
    add a,a
    add a,a
.loop1
    ld (hl),a
    inc hl
    ld a,h
    cp #a0
    jr nz,.loop0

;

sky_blur

    ld b,8
.loop0
    push bc
    ld h,#80
.loop1
    push hl
    ld e,(hl)
    inc hl
    call adrMask
    ld d,(hl)
    ld bc,#1f
    add hl,bc
    call adrMask
    ld c,(hl)
    inc hl
    call adrMask
    ld a,(hl)
    add a,c
    srl a
    ld c,a
    ld a,e
    add a,d
    srl a
    add a,c
    srl a
    pop hl
    ld (hl),a
    inc hl
    ld a,h
    cp #a0
    jr nz,.loop1
 
    pop bc
    djnz .loop0

;

sky_gradient

    ld h,#80
    ld de,#0040
    ld bc,#c00a
.loop0
    push bc
    ld b,32
.loop1
    ld a,(hl)
    cp e
    jr c,$+3
    ld a,e
    cp c
    jr nc,$+3
    ld a,c
    ld (hl),a
    inc hl
    djnz .loop1
    inc d
    ld a,d
    cp 3
    jr c,$+4
    ld d,b
    dec e
    pop bc
    djnz .loop0

;   

sky_render

    ld de,#8000
    ld h,e
.loop0
    ld b,32
.loop1
    ld c,b
    ld b,8
    ld a,(de)
.loop2
    push hl
    call getPixAddr
    ld (hl),a
    pop hl
    inc l
    djnz .loop2
    inc de
    ld b,c
    djnz .loop1
    inc h
    ld a,h
    cp 192
    jr nz,.loop0
 
; 

city_render

.loop0
    call rnd
    and 31
    cp 20
    jr c,$+4
    sub 20
    add a,5
    ld e,a
    call rnd
    and 7
    add a,4
    ld b,a
.loop1
    ld c,b
    ld b,e
    ld h,191
.loop2
    push hl
    call getPixAddr
    ld (hl),0
    pop hl
    dec h
    djnz .loop2
    ld b,c
    inc l
    jr z,.loop3
    djnz .loop1
    jr .loop0
.loop3

;

tower_render

    ld h,l
    ld de,towerData
.loop0
    ld a,(de)
    cp 255
    jr z,.loop6
    ld c,a
    inc de
    ld a,(de)
    ld b,a
    inc de
    push de
.loop1
    ld a,c
    or a
    jr z,.loop5
    push bc
    push hl
    ld b,c
    ld a,99
    srl c
    sub c
    ld l,a
    push hl
    call getPixAddr
    ld (hl),24
    inc l
.loop2
    ld (hl),0
    inc l
    djnz .loop2
    ld (hl),16
    pop hl
    srl c
    ld b,c
    ld a,c
    or a
    jr z,.loop4
    ld a,100
    sub c
    srl c
    sub c
    ld l,a
    ld a,191
    sub h
    cp 24
    jr c,$+4
    ld a,24
    call getPixAddr
.loop3
    ld (hl),a
    inc l
    djnz .loop3
.loop4
    pop hl
    pop bc
.loop5
    inc h
    djnz .loop1
    pop de
    jr .loop0
.loop6

;

flash_render

    ld a,8
.loop0
    push af
    ld b,a
    call rnd
    and 7
    add a,100-4
    ld l,a
    call rnd
    and 7
    add a,32-4
    ld h,a
    ld a,4
    call drawCircle
    pop af
    add a,4
    cp 64
    jr c,.loop0

;

lighting_render

    ld ix,lightingData
.loop0
    ld a,(ix+0)
    or a
    jr z,.loop1
    ld l,(ix+1)
    ld h,(ix+2)
    ld e,(ix+3)
    ld d,(ix+4)
    call drawLine
    ld bc,5
    add ix,bc
    jr .loop0
.loop1
 
;   

render_screen

    ld hl,0
    ld de,#8000+257
    call lineCopy

    ld hl,#4000
    ld a,l
.loop0
    push af
    push hl
    push hl
 
    ld hl,#8000+257
    ld de,#8000
    ld bc,257
    ldir
    ld h,a
    ld l,0
    call lineCopy

    pop hl
    ld ix,#8000
    ld iy,#8000+257
.loop1
    push hl
    ld de,128
.loop2
    ld bc,0
    bit 7,(ix)
    jr z,.loop3
    ld a,d
    or e
    ld d,a
    ld c,63
.loop3
    ld a,(ix)
    sub c
    ld c,a
    ld h,b
    ld l,c
    call div16
    ld a,(iy+1)
    add a,l
    ld (iy+1),a
    ld h,b
    ld l,c
    add hl,hl
    add hl,bc
    call div16
    ld a,(iy-1)
    add a,l
    ld (iy-1),a
    ld h,b
    ld l,c
    add hl,hl
    add hl,hl
    add hl,bc
    push hl
    call div16
    ld a,(iy)
    add a,l
    ld (iy),a
    ld h,b
    ld l,c
    pop hl
    add hl,bc
    add hl,bc
    call div16
    ld a,(ix+1)
    add a,l
    ld (ix+1),a
    srl e
    inc ix
    inc iy
    jr nz,.loop2
    pop hl
    ld (hl),d
    inc l
    ld a,l
    and #1f
    jr nz,.loop1
    pop hl
 
;DOWN_HL+ by Spencer Winsent
    inc h
    ld a,h
    and #07
    jr nz,.loop4
    ld a,l
    sub #e0
    ld l,a
    sbc a,a
    and #f8
    add a,h
    ld h,a
.loop4

    pop af
    inc a
    cp 192
    jp nz,.loop0

; 

set_color
.loop0
    ld (hl),#47
    inc hl
    bit 2,h
    jr z,.loop0

    jr $
 
 
;   
;hl=#8000+(hl&#1fff)

adrMask
    ld a,h
    and #1f
    or #80
    ld h,a
    ret

;      
;h=Y,l=X

getPixAddr
    exa
    ld a,h
    rlca
    rlca
    and 3
    cp 2
    jr c,$+3
    inc a
    out (#fd),a
    ld a,h
    or #c0
    ld h,a
    exa
    ret

;  

lineCopy
    call getPixAddr
    ld bc,256
    ldir
    ret

; 
;h=Y,l=X,b=R,a=

drawCircle
    ld (.col),a
    push bc
    push hl
    ld a,16
    out (#fd),a
    ld c,b
    ld b,0
    push bc
    call STACK_BC
    pop bc
    call STACK_BC
    rst #28
    db #04 ;multiply
    db #38 ;end calc
    call FP_TO_BC
    ld (.k),bc
    pop hl
    pop bc
    ld c,b
    ld d,0
.loop0
    push bc
    push hl
    ld b,c
    ld e,0
.loop1
    push bc
    push de
    push hl
    ex de,hl
    ld a,h
    ld h,rrTable/256
    ld e,(hl)
    inc h
    ld d,(hl)
    ld l,a
    ld h,rrTable/256
    ld c,(hl)
    inc h
    ld b,(hl)
    ex de,hl
    add hl,bc
.k=$+1
    ld bc,0
    sbc hl,bc
    pop hl
    pop de
    jr nc,.loop2
    push hl
    ld a,h
    add a,d
    ld h,a
    ld a,l
    add a,e
    call .setp
    pop hl
    push hl
    ld a,h
    dec a
    sub d
    ld h,a
    ld a,l
    add a,e
    call .setp
    pop hl
    push hl
    ld a,h
    add a,d
    ld h,a
    ld a,l
    dec a
    sub e
    call .setp
    pop hl
    push hl
    ld a,h
    dec a
    sub d
    ld h,a
    ld a,l
    dec a
    sub e
    call .setp
    pop hl
.loop2
    pop bc
    inc e
    djnz .loop1
    pop hl
    pop bc
    inc d
    djnz .loop0
    ret

.setp
    ld l,a
    call getPixAddr
    ld a,(hl)
.col=$+1
    add a,0
    cp 64
    jr c,$+4
    ld a,64
    ld (hl),a
    ret

; 
;h=Ys,l=Xs,d=Ye,e=Xe,a=

drawLine
    ld (.col),a
    push hl
    ld bc,(OP_INC_H<<8)|OP_INC_L
    ld a,e
    sub l
    jr nc,.loop0
    inc c
    cpl
.loop0
    ld e,a
    ld a,d
    sub h
    jr nc,.loop1
    inc b
    cpl
.loop1
    ld d,a
    cp e
    ld a,0
    jr c,.loop2
    ld a,d
    ld d,e
    ld e,a
    ld a,1
.loop2
    or a
    jr nz,.loop3
    ld a,b
    ld b,c
    ld c,a
.loop3
    ld a,c
    ld (.xinc),a
    ld a,b
    ld (.yinc),a
    ld a,e
    ld (.E),a
    ld (.denom),a
    ld a,d
    ld (.T),a
    pop hl

.loop4

    push hl
    push de
.col=$+1
    ld a,0
    push af
    ld b,2
    push hl
    call drawCircle
    pop hl
    call rnd
    and 15
    cp 8
    pop af
    jr nc,.setp0
    push af
    call rnd
    and 7
    sub 3
    add a,h
    ld h,a
    call rnd
    and 7
    sub 3
    add a,l
    ld l,a
    call rnd
    and 7
    add a,4
    ld b,a
    pop af
    call drawCircle
.setp0
    pop de
    pop hl

.E=$+1
    ld a,0
.T=$+1
    sub 0
    jr nc,.loop5
.xinc=$
    nop
.denom=$+1
    add a,0
.loop5
    ld (.E),a
.yinc=$
    nop
    dec e
    jr nz,.loop4
    ret
 
; hl  16

div16
    srl h
    rr l
    srl h
    rr l
    srl h
    rr l
    srl h
    rr l
    ret
 
;  ,  - 

rnd
.r1=$+1
    ld a,12
    ld d,a
.r2=$+1
    ld a,34
    ld (.r1),a
    add a,d
    ld d,a
.r3=$+1
    ld a,56
    ld (.r2),a
    add a,d
    rlca
    ld (.r3),a
    ret


towerData
    db 0,32,1,6,3,1,1,6,4,1,2,6,4,1,3,8,5,1,3,8,5,2,3,6,8,2,12,12,10,6,5,20,7,2,5,10,9,2,7,5,5,20,7,20,9,14,255
lightingData
    db 6,240,0,226,35
    db 6,226,35,196,14
    db 6,196,14,175,40
    db 6,175,40,145,35
    db 6,145,35,130,16
    db 6,130,16,100,32
    db 4,250,0,240,22
    db 4,240,22,208,27
    db 4,208,27,186,16
    db 4,186,16,164,44
    db 4,164,44,146,23
    db 4,146,23,100,32
    db 2,205,25,204,40
    db 2,204,40,196,42
    db 2,186,16,171,8
    db 2,171,8,164,14
    db 2,145,35,136,42
    db 2,136,42,128,36
    db 0


end

    align 256
rrTable
    ds 256*2

    display /d,end-begin
    savesna "citystrm.sna",begin
    savebin "citystrm.bin",begin,end-begin